<script>
import config from "../../config";
import pagination from "laravel-vue-pagination";
import { CustomerService } from "../../services";
import { error_message, debounce } from "../../Helper/helper";

export default {
  components: { pagination },
  data() {
    const { status, orderBy, sortBy } = this.$route.query;
    return {
      config: config,
      sortBy: sortBy || "created_at",
      sortDesc: orderBy && orderBy != '' ? orderBy : true,
      customers: [],
      customerData: [],
      customerCount: '',
      paginations: {},
      limit: 2,
      search: "",
      status: status == undefined ? "0" : status,
      loading: true,
      isDownloading: false,
      searchData: debounce(() => {
        const { status, orderBy, sortBy } = this.$data;
        if(sortBy){
          this.$router.replace({ name: 'customer-list', query: { status, orderBy, sortBy } })
          this.getCustomerList();
        }
        // this.customerExportCsv();
      }, 500),
      fields: [
        {
          key: "unique",
          label: this.trans.get("__JSON__.Customer ID"),
          sortable: false,
        },
        {
          key: "user_name",
          label: this.trans.get("__JSON__.Name"),
          sortable: true,
        },
        {
          key: "email",
          label: this.trans.get("__JSON__.Email"),
          sortable: false,
        },
        {
          key: "address",
          label: this.trans.get("__JSON__.Address"),
          sortable: false,
        },
        {
          key: "mobile_number",
          label: this.trans.get("__JSON__.Phone Number"),
          sortable: false,
        },
        {
          key: "order_count",
          label: this.trans.get("__JSON__.Orders"),
          sortable: true,
        },
        {
          key: "status",
          label: this.trans.get("__JSON__.Status"),
          sortable: false,
        },
        {
          key: "action",
          label: this.trans.get("__JSON__.Action"),
          sortable: false,
        },

      ],
    };
  },
  mounted() {
    this.getCustomerList();
    // this.customerExportCsv();
  },
  methods: {
    onRowClicked(item) {
      this.$router.push({ name: 'customer-detail', params: { user_id: this.base64(item.id) } })
    },
    downloadsCSV: function () {
      let customerData = "\ufeff" + "Customer Id,Name,Email,Address,Phone Number,Order,Status\n";
      this.customerData.forEach((el) => {
        var line =
        el["unique"] +
        "," +
        el["user_name"] + " " + (el["last_name"] ? el["last_name"] : "") +
        "," +
        (el["email"] ? el["email"] : '-') +
        "," +
        (el["address"] ? el["address"] : "").replaceAll( ","," ") +
        "," +
        (el["mobile_number"] ? el["mobile_number"] : '-') +
        "," +
        el["order_count"] +
        "," +
        (el["status"] == 0 ? "Active" : "Inactive") +
        "\n";
        customerData += line;
      });
      var blob = new Blob([customerData], { type: "csv/plain" });
      var currentDate = new Date();
      var date = new Date().toLocaleString();
      let link = document.createElement("a");
      link.href = window.URL.createObjectURL(blob);
      link.download = "Customers" + date + ".csv";
      link.click();
    },
    getCustomerList(page) {
      this.loading = true;
      var filters = {
        search: this.search,
        status: this.status,
        sortBy: this.sortBy,
        orderBy: this.sortDesc ? "desc" : "asc",
        page: page && page > 0 ? page : 1,
      }
      CustomerService
        .getCustomer(filters)
        .then((response) => {
          this.loading = false;
          this.paginations = response.data.result.data;
          this.customers = response.data.result.data.data;
          this.customerCount = response.data.result.customerCount;
        });
    },
    customerExportCsv() {
      this.isDownloading = true;
      CustomerService
        .customerExportCsv({ status: this.status, sortBy: this.sortBy, orderBy: this.sortDesc ? "desc" : "asc" })
        .then((response) => {
          this.isDownloading = false;
          this.customerData = response.data.result;
          this.downloadsCSV();
        });
    },
    sortingChanged(ctx) {
      this.sortBy = ctx.sortBy;
      if(this.sortBy) {
        this.sortDesc = ctx.sortDesc;
        if(this.sortBy !== ""){
          this.getCustomerList();
        }
      }
      // this.customerExportCsv();
    },
  },
};
</script>

<template>
  <div>
    <div class="row header-new">
      <div class="col-12">
        <div class="d-flex align-items-center justify-content-between icon-main-page customer-list">
          <div class="page-title-left">
            <div class="avatar-xs mr-3">
              <span class="avatar-title rounded-circle bg-soft-primary text-primary font-size-18">
                <i class="bx bx-user"></i>
              </span>
            </div>
            <h4 class="mb-0 font-size-18">{{ trans.get('__JSON__.Customers') }}({{ customerCount }})</h4>
          </div>
          <div class="page-title-right align-items-center d-flex">

            <button @click="customerExportCsv"
              class="btn btn-primary btn-rounded export-btn mr-2 avatar-xs d-flex align-items-center justify-content-center"
              v-if="isDownloading" disabled><i class="bx bx-download bx-xs" v-b-tooltip.hover.v-light
                :title="trans.get('__JSON__.Exporting...')"></i>
            </button>

            <button @click="customerExportCsv"
              class="btn btn-primary btn-rounded export-btn mr-2 avatar-xs d-flex align-items-center justify-content-center"
              v-else-if="$auth.hasPermission(config.permissions.customer_read)"><i class="bx bx-export bx-xs"
                v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Export To CSV')"></i></button>

            <button @click="customerExportCsv" class="btn btn-primary btn-rounded m-export-btn"><i class="bx bx-archive-in"></i>
            </button>
            
            <div class="col-sm-4 brand-status">
              <div class="form-group">
                <div class="date-range-list">
                  <select class="custom-select" v-model="status" @change="searchData()">
                    <option value="">{{ trans.get('__JSON__.All') }}</option>
                    <option value="0" selected>{{ trans.get('__JSON__.Active') }}</option>
                    <option value="1">{{ trans.get('__JSON__.Inactive') }}</option>
                  </select>
                </div>
              </div>
            </div>

            <div class="date-range-list">
              <div class="text-sm-right">
                <div class="search-box d-inline-block">
                  <div class="position-relative">
                    <input type="text" class="form-control" id="search" @input="searchData()" v-model="search"
                      :placeholder="trans.get('__JSON__.Search Placeholder')" />
                    <i class="bx bx-search-alt search-icon"></i>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row list-table-main">
      <div class="col-12">
        <div class="card">
          <div class="card-body">
            <div class="table-main-list customer-table table-responsive table-border-0 scroll-table">
              <b-table :items="customers" :fields="fields" :sort-by.sync="sortBy" :sort-desc.sync="sortDesc"
                :no-local-sorting="true" @sort-changed="sortingChanged" :busy="loading" show-empty
                @row-clicked="onRowClicked">
                <template #table-busy>
                  <div class="text-center text-danger my-2">
                    <b-spinner class="align-middle"></b-spinner>
                    <strong>{{ trans.get('__JSON__.Loading...') }}</strong>
                  </div>
                </template>

                <template v-slot:cell(unique)="data">
                  <h5 class="font-size-14">{{ data.item.unique }}</h5>
                </template>

                <template v-slot:cell(user_name)="data">
                  <h5 class="font-size-14">{{ data.item.user_name }} {{ data.item.last_name }}</h5>
                </template>

                <template v-slot:cell(email)="data">
                  <div v-if="data.item.email">
                    {{ data.item.email }}
                  </div>
                  <div v-else>
                    -
                  </div>
                </template>

                <template v-slot:cell(address)="data">
                  <div v-if="data.item.address">
                    <div v-if="data.item.address.length > 60">{{ data.item.address.substr(0, 60) + '...' }}</div>
                    <div v-else>{{ data.item.address }}</div>
                  </div>
                </template>

                <template v-slot:cell(mobile_number)="data">
                  <div v-if="data.item.mobile_number">
                    {{ data.item.mobile_number }}
                  </div>
                  <div v-else>
                    -
                  </div>
                </template>

                <template v-slot:cell(order_count)="data">
                  <div v-if="data.item.order_count">
                    {{ data.item.order_count }}
                  </div>
                  <div v-else>
                    0
                  </div>
                </template>

                <template v-slot:cell(status)="data">
                  <div v-if="data.item.status === '1'" class="badge badge-pill badge-soft-danger font-size-12">{{
                    trans.get('__JSON__.Inactive') }}</div>
                  <div v-else class="badge badge-pill badge-soft-success font-size-12">{{ trans.get('__JSON__.Active')
                  }}</div>
                </template>

                <template v-slot:cell(action)="data">
                  <router-link :to="{ name: 'customer-detail', params: { user_id: base64(data.item.id) } }"
                    class="btn btn-primary btn-sm btn-rounded">View</router-link>
                </template>

                <template #empty>
                  <p class="text-center">{{ trans.get('__JSON__.No Customer') }}</p>
                </template>
              </b-table>
            </div>
            <div class="row col-sm-5 offset-sm-7">
              <div class="col">
                <div class="dataTables_paginate paging_simple_numbers float-right">
                  <ul class="pagination pagination-rounded mb-0">
                    <!-- pagination -->
                    <pagination :data="paginations" :limit="limit" @pagination-change-page="getCustomerList">
                    </pagination>
                  </ul>
                </div>
              </div>
            </div>
            <!-- </div> -->
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.customer-table .table thead th:nth-child(1),.customer-table .table thead th:nth-child(7){
    pointer-events: none;
}
</style>